From 11554ab818307244a9f84f7542ff16515b5a4a01 Mon Sep 17 00:00:00 2001
From: guowenxue <guowenxue@gmail.com>
Date: Fri, 21 Aug 2020 21:47:21 +0800
Subject: [PATCH] Add bluez build shell script

---
 3rdparty/bluez/build.sh |  137 +++++++++++++++++++++++++++++++++++++++++++++
 1 files changed, 137 insertions(+), 0 deletions(-)

diff --git a/3rdparty/bluez/build.sh b/3rdparty/bluez/build.sh
new file mode 100755
index 0000000..ebac3f7
--- /dev/null
+++ b/3rdparty/bluez/build.sh
@@ -0,0 +1,137 @@
+#!/bin/bash
+
+#+--------------------------------------------------------------------------------------------
+#|Description:  This shell script used download and compile bluez for ARM
+#|     Author:  GuoWenxue <guowenxue@gmail.com>
+#|  ChangeLog:
+#|           1, Initialize 1.0.0 on 2011.04.12
+#+--------------------------------------------------------------------------------------------
+
+PREFIX_PATH=`pwd`/../install
+mkdir -p ${PREFIX_PATH}/{bin,sbin,include,lib}
+
+LYFTP_SRC=ftp://master.iot-yun.club/src/
+
+CROSSTOOL=/opt/xtools/arm920t/bin/arm-linux-
+
+function msg_banner()
+{
+    echo ""
+    echo "+-----------------------------------------------------------------------"
+    echo "|  $1 "
+    echo "+-----------------------------------------------------------------------"
+    echo ""
+}
+
+function check_result()
+{
+    if [ $? != 0 ] ; then
+       echo ""
+       echo "+-----------------------------------------------------------------------"
+       echo "|  $1 "
+       echo "+-----------------------------------------------------------------------"
+       echo ""
+       exit ;
+    fi
+}
+
+function export_cross()
+{
+    # export cross toolchain
+    export CC=${CROSSTOOL}gcc
+    export CXX=${CROSSTOOL}g++
+    export AS=${CROSSTOOL}as
+    export AR=${CROSSTOOL}ar
+    export LD=${CROSSTOOL}ld
+    export NM=${CROSSTOOL}nm
+    export RANLIB=${CROSSTOOL}ranlib
+    export OBJDUMP=${CROSSTOOL}objdump
+    export STRIP=${CROSSTOOL}strip
+
+    # export cross configure 
+    export CONFIG_CROSS=" --build=i686-pc-linux --host=arm-linux "
+
+    # Clear LDFLAGS and CFLAGS
+    export LDFLAGS=
+    export CFLAGS=
+}
+
+function compile_bluez_lib()
+{
+    SRC_NAME=bluez-libs-3.36
+    PACK_SUFIX=tar.gz
+
+    if [ -f ${PREFIX_PATH}/lib/libbluetooth.a ] ; then
+        msg_banner "$SRC_NAME already compile and installed"
+        return 0;
+    fi
+
+    msg_banner "Start cross compile $SRC_NAME "
+
+    if [ ! -f ${SRC_NAME}.${PACK_SUFIX} ] ; then
+        #wget http://bluez.sf.net/download/${SRC_NAME}.${PACK_SUFIX}
+        wget ${LYFTP_SRC}/${SRC_NAME}.${PACK_SUFIX}
+
+        check_result "ERROR: download ${SRC_NAME} failure"
+    fi
+
+    tar -xzf ${SRC_NAME}.${PACK_SUFIX}
+    cd ${SRC_NAME}
+
+    ./configure --prefix=${PREFIX_PATH} ${CONFIG_CROSS} --enable-static --disable-shared
+    check_result "ERROR: configure ${SRC_NAME} failure"
+
+    make  && make install
+    check_result "ERROR: compile ${SRC_NAME} failure"
+
+    cd -
+}
+
+function compile_bluez()
+{
+    SRC_NAME=bluez-utils-3.36
+    PACK_SUFIX=tar.gz
+
+    if [ -f ${PREFIX_PATH}/bin/hcitool ] ; then
+        msg_banner "$SRC_NAME already compile and installed"
+        return 0;
+    fi
+
+    msg_banner "Start cross compile $SRC_NAME "
+
+    if [ ! -f ${SRC_NAME}.${PACK_SUFIX} ] ; then
+        #wget http://bluez.sf.net/download/${SRC_NAME}.${PACK_SUFIX}
+        wget ${LYFTP_SRC}/${SRC_NAME}.${PACK_SUFIX}
+
+        check_result "ERROR: download ${SRC_NAME} failure"
+    fi
+
+    tar -xzf ${SRC_NAME}.${PACK_SUFIX}
+    cd ${SRC_NAME}
+
+    export CFLAGS=-I${PREFIX_PATH}/include/
+    export LDFLAGS=-L"${PREFIX_PATH}/lib -lbluetooth"
+    export BLUEZ_CFLAGS=-I${PREFIX_PATH}/include/
+    export BLUEZ_LIBS=-L"${PREFIX_PATH}/lib -lbluetooth"
+    export DBUS_CFLAGS="-I${PREFIX_PATH}/include/dbus-1.0/ -I${PREFIX_PATH}/lib/dbus-1.0/include/"
+    export DBUS_LIBS="-L${PREFIX_PATH}/lib -ldbus-1"
+
+    ./configure --prefix=${PREFIX_PATH} ${CONFIG_CROSS} --enable-static --disable-shared  --disable-glib \
+        --disable-alsa --enable-network --enable-serial --enable-input --enable-audio --enable-hid2hci
+    check_result "ERROR: configure ${SRC_NAME} failure"
+
+    make  && make install
+    check_result "ERROR: compile ${SRC_NAME} failure"
+
+    cd -
+}
+
+cd ../dbus && ./build.sh && cd -
+
+export_cross
+
+compile_bluez_lib
+
+compile_bluez
+
+

--
Gitblit v1.9.1